# function [x,y] = cog(M) 
#	calculate center of gravity of matrix M 

function [x,y] = cog(M)

  [r,c] = size(M);

  r_idx =  (1:r)'*(zeros(1,c)+1);
  c_idx =  (zeros(r,1)+1)*(1:c);
  
  x = sum(sum(c_idx.*M))/sum(sum(M));
  y = sum(sum(r_idx.*M))/sum(sum(M));

endfunction
