# function [x,y] = cog2(M) 
#	calculate center of gravity of matrix M 
#	using stim-resp method

function [x,y] = cog2(M)

  [r,c] = size(M);

  resp_sum = 0.0;
  x = 0.0;
  y = 0.0;

  for i=1:r
	for j=1:c
		g = gaussian(r,c,2,2,i,j,0);
		resp = sigmoid(sum(sum(g.*M)),2.0)-0.5;
		resp_sum = resp_sum + resp;
		x = x + resp*j;
		y = y + resp*i;	
	endfor
  endfor

  x = x / resp_sum;
  y = y / resp_sum;

endfunction
