#!/usr/bin/perl

$usage = <<'EOF';
usage: gen-art-orcog.pl <num-repeat> <slope> <randomness> same|diff cog|or|x|incrcog


	<num-repeat> is how many time you will repeat /~\_/~\ ...
	the change in gradient, where the or and cog gradients are 
	either the same or different.

	<rand> is the degree of randomness, between 0.0 to 1.0.

	<slope> determines the slope of the rise and fall of the /~\s.
	The higher, the steeper. Usual values are 1 to 10.

	generates or or cog file. 
EOF

if ($#ARGV != 4) {
	print $usage;
	exit;
}

$n = $ARGV[0];
$slope = $ARGV[1];
$rand = $ARGV[2];
$sign = ($ARGV[3] eq "same")?1:-1;
$cogflag = $ARGV[4];

$num_pts = 30;

$size = $num_pts*2*$n;

print STDERR $size."\n";

for ($j=0; $j<$size; ++$j) {
	for ($k=0; $k<$n; ++$k) {
		print &curve($num_pts,$rand,$sign,$slope,$cogflag,0);
		print " ";
		print &curve($num_pts,$rand,$sign*(-1.0),$slope,$cogflag,0);
	}
	print "\n";
}
#----------------------------------------------------------------------------
#	subroutines
#----------------------------------------------------------------------------
sub curve {

	my ($num_pts,$rand,$sign,$slope,$cog,$adder) = @_;
	my $i, $x, $str, @val, $v;

	$str = ""; 
	$x = 0.0;


	for ($i=0; $i<$num_pts; ++$i) {

		$x = ($i+1)/(1.0*$num_pts);
		$val[$i] = ($x**($slope*1.0)*(1-$rand)+rand($rand));

	}
	
	my @rev = reverse(@val);

	if ($sign>0) {
		for ($i=0; $i<$num_pts; ++$i) {
			my $prev = 0; # ($i>0)?$val[$i-1]:0;
			$v = ($val[$i]+(($cog eq "incrcog")?$prev:0));
			$str .= $v.(($cog eq "cog")?":0 ":" ");
		}
	} else {
		for ($i=0; $i<$num_pts; ++$i) {
			my $prev = 0; # ($i>0)?$val[$i-1]:0;
			$v = ($rev[$i]+(($cog eq "incrcog")?$prev:0));
			$str .= $v.(($cog eq "cog")?":0 ":" ");
		}
	}

	# chop $str;

	return $str;

}

