#!/usr/bin/perl

$usage = <<EOF;
usage: motifs.pl -s [-c <m>] 

	-s 	: allow self-connections
	-c <m> 	: color nodes with <m> different shades
	<n>	: number of nodes

	prints out different number of motifs under different
	assumptions.

EOF


require "getopts.pl";
&Getopts('-s-c:');

if ($#ARGV!=0) {
	print $usage;
	exit;
}

$n = 3; # for now, n is fixed to 3.

$rep_count=0;
$edges = $n*($n-1)/2;
$raw   = 3**$edges;
print "[$rep_count]\tRaw count\t= $raw\n";
$rep_count++;

# basic non-isomorphic set without recurrence
#
#	1
#
#     2   3
#
#	- edge label 0 : src -> tgt; 1: src <- tgt; 2: bidirectional

for ($s=0; $s<3; ++$s) { # for all three nodes
	$nin[$s] = 0
	$nout[$s] = 0
}

for ($i = 0; $i<=2; ++$i) { # 1 and 2
  for ($j = 0; $j<=2; ++$j) { # 2 and 3
    for ($k=0; $k<=2; ++$k) { # 3 and 4
	for ($s=0; $s<3; ++$s) { # for all three nodes
		$nout[$s] += ($i+1)%2;
		$nin[$s]  += $i%2;
		

		



