#!/usr/bin/perl

$usage = "usage: ordiff.pl <or1> <or2>\n";

if ($#ARGV != 1) {
	print $usage;
	exit;
}

$ordiff = &calc_ordiff($ARGV[0]/180.0,$ARGV[1]/180.0);

print "Diff $ARGV[0] and $ARGV[1]: $ordiff\n";

sub min {

  my ($x,$y) = @_;

  if ($x>$y) {
	return $y;
  } else {
	return $x;
  }
}

sub max {

  my ($x,$y) = @_;

  if ($x>$y) {
	return $x;
  } else {
	return $y;
  }
}

sub calc_ordiff {
  my ($or1,$or2) = @_;

  my $mx = &max($or1,$or2);
  my $mn = &min($or1,$or2);

  my $ordiff = $mx-$mn;
  if ($ordiff > 0.5) {
     $ordiff = 1.0-$ordiff;
  }
  $ordiff *=180;
  return $ordiff;

}

