#!/usr/bin/wish

# animate the movement of the visual field

global coord screen_w screen_h cols rows zoom max_loc cx cy

set zoom 4

#----------------------------------------------------------------------------
# 	plotnet: plot c.o.g.s net 
#----------------------------------------------------------------------------
proc plotnet { } {

	global coord  screen_w screen_h cols rows max_loc cx cy
	
 	set granx [expr $screen_w / $cols];
 	set grany [expr $screen_h / $rows];
	set radius [expr $granx * 3];

	for {set j 0} {$j<$max_loc} {incr j} {

		set lcx [expr $cx($j)*$granx-$radius]
		set lcy [expr $cy($j)*$grany-$radius]

		.misc.net create oval\
			$lcx $lcy \
			[expr $lcx + 2*$radius] [expr $lcy + 2*$radius] \
			-width 2  -tags [list oval]
		.misc.net create oval\
			[expr $lcx + $radius] [expr $lcy + $radius] \
			[expr $lcx + $radius + 1] [expr $lcy + $radius + 1] \
			-width 1 -tags [list dot]
		update
		after 50	
		.misc.net delete allOvals withtag oval
		update
	}
}


#----------------------------------------------------------------------------
#
# 	MAIN:
#
#----------------------------------------------------------------------------
if {[llength $argv] <= 1} {
  puts "usage: vfanim.tcl <rows> <cols> <vfcoordinatefile> [zoom: default=4]"
  exit
}

#----------------------------------------
# 1. Load E data
#----------------------------------------
set fp [open [lindex $argv 2]]

set idx 0

#--------------------
# get rows
#--------------------
set rows [lindex $argv 0]
puts "rows: $rows"

#--------------------
# get columns
#--------------------
set cols [lindex $argv 1]
puts "cols: $cols"

#--------------------
# get data
#--------------------
set j 0

while {![eof $fp]} {
  
  set line [gets $fp]

  if {[eof $fp]} {
		break
  }

  set column_data [split $line "\t"]

  set cx($j) [expr [lindex $column_data 0]]
  set cy($j) [expr [lindex $column_data 1]]

  incr j
}
set max_loc $j
close $fp

#--------------------
# get zoom ratio
#--------------------
if {[llength $argv] == 4} {
        set zoom [lindex $argv 3]
        puts "zoom: $zoom"
} else {
	puts "zoom: $zoom"
}


#----------------------------------------
# 2. Create polar line display window
#----------------------------------------
frame .misc -relief ridge; pack .misc -padx 10 -pady 10

set screen_w [expr $cols * $zoom]
set screen_h [expr $rows * $zoom]

canvas .misc.net -relief sunken -borderwidth 1 -background white \
	-width $screen_w -height $screen_h;
pack .misc.net -side left -padx 10 -pady 5 ; 

button .animate -command { \
	plotnet
        # .misc.net postscript -file edgelines.ps ; \
        } -text "Animate"
pack .animate -side left

button .cleartrace -command { \
	.misc.net delete allOvals withtag dot; \
	update; } -text "Clear Trace"
pack .cleartrace -side left

button .quit -command { exit } -text "Quit"
pack .quit -side top -padx 10 -pady 10

